## asterisk 20.8.1~dfsg+~cs6.14.40431414

=== debian/changelog ===
asterisk (1:20.8.1~dfsg+~cs6.14.40431414-1) unstable; urgency=medium

  [ upstream ]
  * new release
    + use PJProject 2.14.1,
      which fixes Use-after-free in SRTP media transport;
      CVE-2023-37457 CVE-2023-38703;
      closes: bug#1059303, thanks to Moritz Mühlenhoff
    + fix regression issues with DTLS client check;
      closes: bug#1068296, thanks to Oleksandr Kozmenko

  [ Jonas Smedegaard ]
  * update watch file:
    + track only LTS releases
    + bump to track pjproject 2.14.1
  * unfuzz patches
  * update copyright info: update coverage
  * declare compliance with Debian Policy 4.7.0
  * create and restrict access to cache dir;
    closes: bug#1072739, thanks to Bastian Triller
  * fix rotate main logfiles,
    as logfiles use suffix .log since Asterisk 19;
    thanks to James Bottomley (see bug#1024822)

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 07 Jun 2024 14:10:19 +0200

=== debian/control ===
Source: asterisk
Priority: optional
Section: comm
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders:
 Bernhard Schmidt <berni@debian.org>,
 Jeremy Lainé <jeremy.laine@m4x.org>,
 Jonas Smedegaard <dr@jones.dk>,
 Mark Purcell <msp@debian.org>,
 Tzafrir Cohen <tzafrir@debian.org>,
Build-Depends:
 autoconf,
 automake,
 binutils-dev,
 cmark-gfm <!nodoc>,
 dahdi-source,
 debhelper-compat (= 13),
 default-libmysqlclient-dev,
 freetds-dev,
 libasound2-dev,
 libavcodec-dev,
 libavdevice-dev,
 libbluetooth-dev [linux-any],
 libc-client2007e-dev,
 libcap-dev [linux-any],
 libcodec2-dev,
 libcurl4-openssl-dev,
 libedit-dev,
 libfftw3-dev,
 libgmime-3.0-dev,
 libgsm1-dev,
 libical-dev,
 libiksemel-dev,
 libjack-dev,
 libjansson-dev,
 libjwt-dev,
 libldap-dev,
 liblua5.1-dev,
 libncurses-dev,
 libneon27-dev,
 libnewt-dev,
 libogg-dev,
 libopencore-amrnb-dev,
 libopencore-amrwb-dev,
 libopenr2-dev [linux-any],
 libopus-dev,
 libopusenc-dev,
 libopusfile-dev,
 libpopt-dev,
 libpq-dev,
 libpri-dev,
 libradcli-dev,
 libreadline-dev,
 libresample1-dev,
 libsdl-image1.2-dev,
 libsndfile1-dev,
 libsnmp-dev,
 libspandsp-dev,
 libspeex-dev,
 libspeexdsp-dev,
 libsqlite3-dev,
 libsrtp2-dev,
 libss7-dev,
 libssl-dev,
 libswscale-dev,
 libsystemd-dev [linux-any],
 libtonezone-dev [linux-any],
 libunbound-dev,
 liburiparser-dev,
 libvo-amrwbenc-dev,
 libvorbis-dev,
 libxml2-dev,
 libxslt1-dev,
 perl <!nodoc>,
 portaudio19-dev,
 systemd-dev,
 unixodbc-dev,
 uuid-dev,
 zlib1g-dev,
Standards-Version: 4.7.0
Homepage: https://www.asterisk.org/
Vcs-Git: https://salsa.debian.org/pkg-voip-team/asterisk.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/asterisk
Rules-Requires-Root: no

Package: asterisk
Architecture: any
Depends:
 adduser,
 asterisk-config (= ${source:Version}) | asterisk-config-custom,
 asterisk-core-sounds-en,
 asterisk-modules (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Provides:
 asterisk-abi-${asterisk:ABI},
Recommends:
 asterisk-moh-opsound-gsm,
 sox,
Suggests:
 asterisk-dahdi,
 asterisk-dev,
 asterisk-doc,
 asterisk-ooh323,
 asterisk-opus,
Description: Open Source Private Branch Exchange (PBX)
 Asterisk is an Open Source PBX and telephony toolkit.
 It is, in a sense, middleware
 between Internet and telephony channels on the bottom,
 and Internet and telephony applications at the top.
 .
 Asterisk can be used with Voice over IP standards
 (SIP, H.323, IAX and more),
 or the Public Switched Telephone Network (PSTN)
 through supported hardware.
 .
 Supported hardware:
 .
  * All Wildcard (tm) ISDN PRI cards from Digium
  * HFC-S/HFC-4S-based ISDN BRI cards
    (Junghanns.NET, beroNet, Digium etc.)
  * All TDM (FXO/FXS) cards from Digium
  * Various clones of Digium cards such as those by OpenVox
  * Xorcom Astribank USB telephony adapter
  * Voicetronix OpenPCI, OpenLine and OpenSwitch cards
  * CAPI-compatible ISDN cards
    (using the add-on package chan-capi)
  * Full Duplex Sound Card (ALSA or OSS) supported by Linux
  * Tormenta T1/E1 card
  * QuickNet Internet PhoneJack and LineJack
 .
 This is the main package
 that includes the Asterisk daemon
 and most channel drivers and applications.

Package: asterisk-modules
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 asterisk-opus (<< 13.7+20171009-2+),
 asterisk-voicemail (<< 1:18),
 asterisk-voicemail-imapstorage (<< 1:18),
 asterisk-voicemail-odbcstorage (<< 1:18),
Breaks:
 asterisk-opus (<< 13.7+20171009-2+),
 asterisk-voicemail (<< 1:18),
 asterisk-voicemail-imapstorage (<< 1:18),
 asterisk-voicemail-odbcstorage (<< 1:18),
Section: libs
Description: loadable modules for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package includes most of the Asterisk loadable modules.
 There is normally no need to explicitly install it.

Package: asterisk-dahdi
Architecture: linux-any
Depends:
 asterisk (= ${binary:Version}),
 dahdi,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 asterisk-modules (<< 1:11.6.0~dfsg-2),
Replaces:
 asterisk-modules (<< 1:11.6.0~dfsg-2),
Description: DAHDI devices support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package includes the DAHDI channel driver (chan_dahdi.so)
 and a number of other Asterisk modules that require DAHDI support.
 They will not be useful without kernel-level DAHDI support.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-ooh323
Architecture: any
Depends:
 asterisk (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: H.323 protocol support for the Asterisk PBX - ooH323c
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This channel driver (chan_ooh323c) provides support
 for the H.323 protocol for Asterisk.
 This is an independent implementation
 that does not depend on OpenH323,
 but may be less functional than the original chan_h323.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-mp3
Architecture: any
Depends:
 asterisk (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: MP3 playback support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides support
 for playing MP3-encoded files in Asterisk.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-mysql
Architecture: any
Depends:
 asterisk (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: MySQL database protocol support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides support for using a MySQL database
 to store configuration, call detail records,
 and also provides generic access to it from the dialplan.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-mobile
Architecture: linux-any
Depends:
 asterisk (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Bluetooth phone support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides support
 for connecting Bluetooth devices to the Asterisk PBX.
 It allows you to:
   * Send and receive PSTN calls and SMS messages
     over a Bluetooth phone.
   * Use a Bluetooth handset as a local phone
     connected to your PBX.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-tests
Architecture: linux-any
Depends:
 asterisk (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: internal test modules of the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides modules
 that run various functionality tests.
 You would normally not install this package
 unless you test a build of Asterisk.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 asterisk,
Section: doc
Description: Source code documentation for Asterisk
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package contains the documentation
 for configuring an Asterisk system.

Package: asterisk-dev
Architecture: all
Multi-Arch: foreign
Depends:
 debhelper,
 perl:any,
 ${misc:Depends},
Recommends:
 asterisk,
Provides:
 dh-sequence-asterisk,
Section: devel
Description: Development files for Asterisk
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package contains the include files
 used if you wish to compile a package
 which requires Asterisk's source file headers.

Package: asterisk-config
Depends:
 ${misc:Depends},
Recommends:
 asterisk,
Conflicts:
 asterisk-config-custom,
Replaces:
 asterisk-config-custom,
Architecture: all
Description: Configuration files for Asterisk
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package contains the default configuration files of Asterisk.
 .
 With program asterisk-config-custom in the asterisk package,
 you can create an asterisk-config replacement package.

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --uscan

opts=\
repacksuffix=~dfsg,\
pgpmode=auto,\
uversionmangle=s/\d\K-(rc)/~~$1/,\
dversionmangle=auto \
https://downloads.asterisk.org/pub/telephony/asterisk/releases/ \
asterisk-(\d[02468](?:\.\d+)+(?:-rc\d)?)@ARCHIVE_EXT@ group

opts=\
component=Xamr,\
mode=git,pgpmode=none,pretty=4.0.%cd,\
dversionmangle=auto \
https://github.com/traud/asterisk-amr.git \
HEAD checksum

opts=\
component=Xmp3,\
mode=svn,pgpmode=none,\
uversionmangle=s/~svn/./,\
dversionmangle=auto \
https://svn.digium.com/svn/thirdparty/mp3/trunk/ \
HEAD checksum

opts=\
component=Xopus,\
mode=git,pgpmode=none,pretty=0.0.%cd,\
dversionmangle=auto \
https://github.com/traud/asterisk-opus.git \
HEAD checksum

opts=\
component=Xpjproject,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-Xpjproject-$1/,\
dversionmangle=auto \
https://github.com/pjsip/pjproject/tags \
.*?(2\.14\.1)@ARCHIVE_EXT@ checksum

## asterisk 20.9.3~dfsg+~cs6.14.60671435

=== debian/changelog ===
asterisk (1:20.9.3~dfsg+~cs6.14.60671435-1) unstable; urgency=high

  [ upstream ]
  * new release(s)
    + add entries to Originate blacklist;
      CVE-2024-42365;
      closes: bug#1078574, thanks to Salvatore Bonaccorso
    + test for NULL ub_result in unbound_resolver_callback;
      CVE-2024-42491

  [ Jonas Smedegaard ]
  * fix minor privilege escalation; thanks to Niels Galjaard
  * update watch file: track mp3 component from git clone
  * unfuzz patch 2012
  * set urgency=high due to security-related bugfixes

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 07 Sep 2024 22:14:21 +0200

## asterisk 22.0.0~~rc2~dfsg+~cs6.14.60671435

=== debian/changelog ===
asterisk (1:22.0.0~~rc2~dfsg+~cs6.14.60671435-1) experimental; urgency=medium

  [ upstream ]
  * new prerelease(s)

  [ Jonas Smedegaard ]
  * update and unfuzz patches
  * adapt build routines and add NEWS entry
    related to no longer provided modules app_macro chan_sip
  * stop build-depend on libasound2-dev;
    stop mention ALSA in long description
    (module chan_alsa not provided for some time)
  * update copyright info: update coverage
  * cleanup new upstream hint file .lastclean
  * fix handle prerelease changelog file

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 05 Oct 2024 11:28:05 +0200

## asterisk 22.0.0~dfsg+~cs6.14.60671435

=== debian/changelog ===
asterisk (1:22.0.0~dfsg+~cs6.14.60671435-1) unstable; urgency=medium

  [ upstream ]
  * new release

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 23 Oct 2024 13:39:34 +0200

## asterisk 22.1.0~dfsg+~cs6.14.60671435

=== debian/changelog ===
asterisk (1:22.1.0~dfsg+~cs6.14.60671435-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update and trust only upstream team signing key 5D984BE337191CE7
  * update copyright info: update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 27 Nov 2024 12:37:42 +0100

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,6 @@
  debhelper-compat (= 13),
  default-libmysqlclient-dev,
  freetds-dev,
- libasound2-dev,
  libavcodec-dev,
  libavdevice-dev,
  libbluetooth-dev [linux-any],
@@ -127,7 +126,6 @@
   * Voicetronix OpenPCI, OpenLine and OpenSwitch cards
   * CAPI-compatible ISDN cards
     (using the add-on package chan-capi)
-  * Full Duplex Sound Card (ALSA or OSS) supported by Linux
   * Tormenta T1/E1 card
   * QuickNet Internet PhoneJack and LineJack
  .

## asterisk 22.1.1~dfsg+~cs6.14.60671435

=== pjsip-apps/src/swig/python/Makefile ===
PYTHON_SO=_pjsua2.so

USE_PYTHON3?=1

ifeq ($(USE_PYTHON3),1)
  PYTHON_EXE=python3
else
  PYTHON_EXE=python2
endif

#PYTHON_SETUP_FLAGS = --inplace 
ifeq ($(OS),Windows_NT)
  PYTHON_PKG_DIR := $(shell $(PYTHON_EXE) -m site --user-site | sed 's/\\/\//g')
  PYTHON_SETUP_FLAGS += --compiler=mingw32
  GCC_EXE=gcc.exe
else
  PYTHON_PKG_DIR := $(shell $(PYTHON_EXE) -m site --user-site)
  GCC_EXE=
endif

SWIG_FLAGS=-I../../../../pjlib/include \
		   -I../../../../pjlib-util/include \
		   -I../../../../pjmedia/include \
		   -I../../../../pjsip/include \
		   -I../../../../pjnath/include -c++ 
SRC_DIR=../../../../pjsip/include
SRCS=$(SRC_DIR)/pjsua2/endpoint.hpp $(SRC_DIR)/pjsua2/types.hpp

USE_THREADS = -threads -DSWIG_NO_EXPORT_ITERATOR_METHODS
SWIG_FLAGS += -w312 $(USE_THREADS)

.PHONY: all install uninstall

all: $(PYTHON_SO)

wheel: pjsua2_wrap.cpp setup.py $(GCC_EXE)
	$(PYTHON_EXE) setup.py bdist_wheel $(PYTHON_SETUP_FLAGS)

$(PYTHON_SO): pjsua2_wrap.cpp setup.py $(GCC_EXE)
	$(PYTHON_EXE) setup.py build $(PYTHON_SETUP_FLAGS)

gcc.exe: cc_mingw.c
	gcc -o gcc.exe cc_mingw.c
	cp gcc.exe g++.exe

pjsua2_wrap.cpp: ../pjsua2.i ../symbols.i Makefile $(SRCS)
	swig $(SWIG_FLAGS) -python -o pjsua2_wrap.cpp ../pjsua2.i

clean distclean realclean:
	rm -rf $(PYTHON_SO) pjsua2_wrap.cpp pjsua2_wrap.h pjsua2.py build *.pyc
	rm -f gcc.exe g++.exe

install:
	$(PYTHON_EXE) setup.py install --user

uninstall:
	rm -f $(PYTHON_PKG_DIR)/pjsua2*
	rm -f $(PYTHON_PKG_DIR)/_pjsua2*

=== debian/changelog ===
asterisk (1:22.1.1~dfsg+~cs6.14.60671435-1) unstable; urgency=medium

  [ upstream ]
  * new release
    + Restrict ListCategories to the configuration directory;
      CVE-2024-53566

  [ Jonas Smedegaard ]
  * update git-buildpackage config:
    + avoid variable abstraction in usage comment

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 13 Jan 2025 00:01:35 +0100

=== debian/watch ===
--- 
+++ 
@@ -19,10 +19,9 @@
 
 opts=\
 component=Xmp3,\
-mode=svn,pgpmode=none,\
-uversionmangle=s/~svn/./,\
+mode=git,pgpmode=none,pretty=0.0.%cd,\
 dversionmangle=auto \
-https://svn.digium.com/svn/thirdparty/mp3/trunk/ \
+https://github.com/ajorians/thirdparty-mp3.git \
 HEAD checksum
 
 opts=\

## asterisk 22.2.0~dfsg%2B~cs6.15.60671435

=== main/Makefile ===
#
# Asterisk -- An open source telephony toolkit.
#
# Makefile to build main Asterisk binary
#
# Copyright (C) 1999-2006, Digium, Inc.
#
# Mark Spencer <markster@digium.com>
#
# This program is free software, distributed under the terms of
# the GNU General Public License
#

-include $(ASTTOPDIR)/menuselect.makeopts $(ASTTOPDIR)/menuselect.makedeps $(ASTTOPDIR)/makeopts

all: asterisk

include $(ASTTOPDIR)/Makefile.moddir_rules

MOD_SRC:=cdr.c cel.c config.c ccss.c dnsmgr.c dsp.c enum.c features.c http.c indications.c logger.c manager.c named_acl.c plc.c sounds.c udptl.c
# Allow deletion of built-in modules without needing to modify this source.
MOD_SRC:=$(wildcard $(MOD_SRC))
MOD_OBJS:=$(sort $(MOD_SRC:.c=.o))

# Must include the extra ast_expr2.c, ast_expr2f.c, in case they need to be regenerated (because to force regeneration, we delete them)
SRC:=$(wildcard *.c) ast_expr2.c ast_expr2f.c
ifeq ($(AST_ASTERISKSSL),yes)
SRC:=$(filter-out libasteriskssl.c,$(SRC))
endif
ifeq ($(PJPROJECT_BUNDLED),yes)
SRC:=$(filter-out libasteriskpj.c,$(SRC))
endif
OBJSFILTER:=$(MOD_OBJS) fskmodem_int.o fskmodem_float.o cygload.o buildinfo.o
SRC_CC:=$(wildcard *.cc)
OBJS=$(filter-out $(OBJSFILTER),$(SRC:.c=.o) $(SRC_CC:.cc=.oo))

# we need to link in the objects statically, not as a library, because
# otherwise modules will not have them available if none of the static
# objects use it.
OBJS+=stdtime/localtime.o

ASTSSL_LIBS:=$(OPENSSL_LIB)
AST_LIBS+=$(BKTR_LIB)
AST_LIBS+=$(LIBXML2_LIB)
AST_LIBS+=$(LIBXSLT_LIB)
AST_LIBS+=$(SQLITE3_LIB)
AST_LIBS+=$(ASTSSL_LIBS)
AST_LIBS+=$(JANSSON_LIB)
AST_LIBS+=$(URIPARSER_LIB)
AST_LIBS+=$(UUID_LIB)
AST_LIBS+=$(CRYPT_LIB)
AST_LIBS+=$(AST_CLANG_BLOCKS_LIBS)
AST_LIBS+=$(RT_LIB)
AST_LIBS+=$(SYSTEMD_LIB)

ifneq ($(findstring $(OSARCH), linux-gnu uclinux linux-uclibc linux-musl kfreebsd-gnu),)
  AST_LIBS+=-ldl
  ifneq (x$(CAP_LIB),x)
    AST_LIBS+=$(CAP_LIB)
  endif
  AST_LIBS+=-lpthread -lm -lresolv
else
  AST_LIBS+=-lm
endif

ifneq ($(findstring BETTER_BACKTRACES,$(MENUSELECT_CFLAGS)),)
  AST_LIBS+=$(BFD_LIB)
endif

ifneq ($(findstring darwin,$(OSARCH)),)
  AST_LIBS+=-lresolv
  ASTLINK=-mmacosx-version-min=10.6 -Wl,-undefined,dynamic_lookup -force_flat_namespace
  ASTLINK+=/usr/lib/bundle1.o
else
# These are used for all but Darwin
  ASTLINK+=-Wl,--export-dynamic
  ifneq ($(findstring BSD,$(OSARCH)),)
    LDFLAGS+=-L/usr/local/lib
  endif
endif

ifeq ($(OSARCH),FreeBSD)
  # -V is understood by BSD Make, not by GNU make.
  BSDVERSION=$(shell make -V OSVERSION -f /usr/share/mk/bsd.port.subdir.mk)
  AST_LIBS+=$(shell if test $(BSDVERSION) -lt 502102 ; then echo "-lc_r"; else echo "-pthread"; fi)
  AST_LIBS+=-lcrypto
endif

ifneq ($(findstring $(OSARCH), mingw32 cygwin ),)
  AST_LIBS+=-lminires -ldl
  ASTLINK+=-shared -Wl,--out-implib,libasterisk.a
endif
ifeq ($(OSARCH),NetBSD)
  AST_LIBS+=-lpthread -lcrypto -lm -L/usr/pkg/lib
endif

ifeq ($(OSARCH),OpenBSD)
  AST_LIBS+=-lcrypto -lpthread -lm
endif

ifeq ($(OSARCH),SunOS)
  AST_LIBS+=-lpthread -ldl -lrt -lnsl -lsocket -lresolv
  ASTSSL_LIBS+=-L/opt/ssl/lib -L/usr/local/ssl/lib
  ASTLINK=
endif

ifneq ($(findstring USE_HOARD_ALLOCATOR,$(MENUSELECT_CFLAGS)),)
  ifneq ($(HOARD_LIB),)
    AST_LIBS+=$(HOARD_LIB)
  endif
endif

ifeq ($(GNU_LD),1)
ASTLINK+=-Wl,--version-script,asterisk.exports
  ifeq ($(HAVE_DYNAMIC_LIST),1)
  ASTLINK+=-Wl,--dynamic-list,asterisk.dynamics
  endif
endif

.PHONY: CHECK_SUBDIR
CHECK_SUBDIR:	# do nothing, just make sure that we recurse in the subdir/

ifneq ($(findstring REBUILD_PARSERS,$(MENUSELECT_CFLAGS)),)
ast_expr2.c ast_expr2.h: ast_expr2.y
else
ast_expr2.c ast_expr2.h:
endif
	$(ECHO_PREFIX) echo "   [BISON] $< -> $@"
	$(CMD_PREFIX) $(BISON) -o $@ -d --name-prefix=ast_yy ast_expr2.y

ifneq ($(findstring REBUILD_PARSERS,$(MENUSELECT_CFLAGS)),)
ast_expr2f.c: ast_expr2.fl
else
ast_expr2f.c:
endif
	$(ECHO_PREFIX) echo "   [FLEX] $< -> $@"
	$(CMD_PREFIX) echo "#define ASTMM_LIBC ASTMM_REDIRECT" > $@
	$(CMD_PREFIX) echo "#include \"asterisk.h\"" >> $@
	$(CMD_PREFIX) echo >> $@
	$(CMD_PREFIX) $(FLEX) -t ast_expr2.fl >> $@

ifneq ($(findstring ENABLE_UPLOADS,$(MENUSELECT_CFLAGS)),)
GMIMELDFLAGS+=$(GMIME_LIB)
GMIMECFLAGS+=$(GMIME_INCLUDE)
endif

# Alter CFLAGS for specific sources
stdtime/localtime.o: _ASTCFLAGS+=$(AST_NO_STRICT_OVERFLOW) -Wno-format-nonliteral

asterisk.o: _ASTCFLAGS+=$(LIBEDIT_INCLUDE)
ast_expr2f.o: _ASTCFLAGS+=-Wno-unused
astmm.o: _ASTCFLAGS+=$(call get_menuselect_cflags,MALLOC_DEBUG DEBUG_CHAOS)
astobj2.o astobj2_container.o astobj2_hash.o astobj2_rbtree.o: _ASTCFLAGS+=$(call get_menuselect_cflags,AO2_DEBUG)
backtrace.o: _ASTCFLAGS+=$(call get_menuselect_cflags,BETTER_BACKTRACES)
bucket.o: _ASTCFLAGS+=$(URIPARSER_INCLUDE)
cdr.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION)
crypt.o: _ASTCFLAGS+=$(CRYPT_INCLUDE)
db.o: _ASTCFLAGS+=$(SQLITE3_INCLUDE)
dsp.o: _ASTCFLAGS+=$(call get_menuselect_cflags,RADIO_RELAX)
frame.o: _ASTCFLAGS+=$(call get_menuselect_cflags,MALLOC_DEBUG)
http.o: _ASTCFLAGS+=$(GMIMECFLAGS)
iostream.o: _ASTCFLAGS+=$(OPENSSL_INCLUDE)
json.o: _ASTCFLAGS+=$(JANSSON_INCLUDE)
lock.o: _ASTCFLAGS+=$(call get_menuselect_cflags,DETECT_DEADLOCKS)
options.o: _ASTCFLAGS+=$(call get_menuselect_cflags,REF_DEBUG)
sched.o: _ASTCFLAGS+=$(call get_menuselect_cflags,DEBUG_SCHEDULER DUMP_SCHEDULER)
tcptls.o: _ASTCFLAGS+=$(OPENSSL_INCLUDE) -Wno-deprecated-declarations
# since we're using open_memstream(), we need to release the buffer with
# the native free() function or we might get unexpected behavior.
test.o: _ASTCFLAGS+=-DASTMM_LIBC=ASTMM_IGNORE
uuid.o: _ASTCFLAGS+=$(UUID_INCLUDE)
stasis.o: _ASTCFLAGS+=$(call get_menuselect_cflags,AO2_DEBUG)
time.o: _ASTCFLAGS+=-D_XOPEN_SOURCE=700


OBJS:=$(sort $(OBJS))

ifneq ($(findstring $(OSARCH), mingw32 cygwin ),)
MAIN_TGT:=asterisk.dll
asterisk: cygload
	mv cygload.exe asterisk.exe

cygload: asterisk.dll
else
MAIN_TGT:=asterisk
endif

$(OBJS): _ASTCFLAGS+=-DAST_MODULE=\"core\" -DAST_IN_CORE
$(MOD_OBJS): _ASTCFLAGS+=$(call MOD_ASTCFLAGS,$*)

libasteriskssl.o: _ASTCFLAGS+=$(OPENSSL_INCLUDE)

ifeq ($(AST_ASTERISKSSL),yes)
# The ABI *version* of the asteriskssl library; don't change this unless there truly is a
# non-backwards-compatible ABI change in the library
ASTSSL_SO_VERSION=1

ASTSSL_LDLIBS=-L. -lasteriskssl

ifeq ($(findstring darwin,$(OSARCH)),) # not Darwin
ASTSSL_LIB:=libasteriskssl.so

$(ASTSSL_LIB).$(ASTSSL_SO_VERSION): _ASTLDFLAGS+=-Wl,-soname=$(ASTSSL_LIB).$(ASTSSL_SO_VERSION)
$(ASTSSL_LIB).$(ASTSSL_SO_VERSION): _ASTCFLAGS+=-fPIC -DAST_MODULE=\"asteriskssl\" -DAST_NOT_MODULE
$(ASTSSL_LIB).$(ASTSSL_SO_VERSION): LIBS+=$(ASTSSL_LIBS)
ifeq ($(GNU_LD),1)
    $(ASTSSL_LIB).$(ASTSSL_SO_VERSION): SO_SUPPRESS_SYMBOLS=-Wl,--version-script,libasteriskssl.exports,--warn-common
endif
$(ASTSSL_LIB).$(ASTSSL_SO_VERSION): SOLINK=$(DYLINK)

# These rules are duplicated from $(ASTTOPDIR)/Makefile.rules because the library name
# being built does not match the "%.so" pattern; there are also additional steps
# required to build a proper shared library (as opposed to the 'loadable module'
# type that are built by the standard rules)
$(ASTSSL_LIB).$(ASTSSL_SO_VERSION): libasteriskssl.o
ifeq ($(GNU_LD),1)
	$(CMD_PREFIX) $(ASTTOPDIR)/build_tools/make_linker_version_script libasteriskssl "$(LINKER_SYMBOL_PREFIX)" "$(ASTTOPDIR)"
endif
	$(ECHO_PREFIX) echo "   [LD] $^ -> $@"
	$(CMD_PREFIX) $(CC) -o $@ $(CC_LDFLAGS_SO) $^ $(CC_LIBS)

$(ASTSSL_LIB): $(ASTSSL_LIB).$(ASTSSL_SO_VERSION)
	$(ECHO_PREFIX) echo "   [LN] $< -> $@"
	$(LN) -sf $< $@ ;\

else # Darwin
ASTSSL_LIB:=libasteriskssl.dylib

# -install_name allows library to be found if installed somewhere other than
# /lib or /usr/lib
$(ASTSSL_LIB): _ASTLDFLAGS+=-dynamiclib -install_name $(ASTLIBDIR)/$(ASTSSL_LIB)
$(ASTSSL_LIB): _ASTCFLAGS+=-fPIC -DAST_MODULE=\"asteriskssl\" -DAST_NOT_MODULE
$(ASTSSL_LIB): LIBS+=$(ASTSSL_LIBS)
$(ASTSSL_LIB): SOLINK=$(DYLINK)

# Special rules for building a shared library (not a dynamically loadable module)
$(ASTSSL_LIB): libasteriskssl.o
	$(ECHO_PREFIX) echo "   [LD] $^ -> $@"
	$(CMD_PREFIX) $(CC) -o $@ $(CC_LDFLAGS_SO) $^ $(CC_LIBS)
endif

endif

libasteriskpj.o: _ASTCFLAGS+=$(PJPROJECT_INCLUDE)

ifeq ($(PJPROJECT_BUNDLED),yes)

ASTPJ_SO_VERSION=2
ASTPJ_LDLIBS=-L. -lasteriskpj

PJDIR=$(ASTTOPDIR)/$(PJPROJECT_DIR)/source
-include $(ASTTOPDIR)/$(PJPROJECT_DIR)/build.mak

PJPROJECT_LDLIBS := \
-Wl,--whole-archive \
$(PJSUA_LIB_LDLIB) \
$(PJSIP_UA_LDLIB) \
$(PJSIP_SIMPLE_LDLIB) \
$(PJSIP_LDLIB) \
$(PJNATH_LDLIB) \
$(PJMEDIA_CODEC_LDLIB) \
$(PJMEDIA_VIDEODEV_LDLIB) \
$(PJMEDIA_AUDIODEV_LDLIB) \
$(PJMEDIA_LDLIB) \
$(PJLIB_UTIL_LDLIB) \
$(PJLIB_LDLIB) \
-Wl,--no-whole-archive \
$(APP_THIRD_PARTY_LIBS) \
$(APP_THIRD_PARTY_EXT)

ifeq ($(findstring darwin,$(OSARCH)),) # not Darwin
ASTPJ_LIB:=libasteriskpj.so

libasteriskpj.exports: $(ASTTOPDIR)/$(PJPROJECT_DIR)/pjproject.symbols
	$(ECHO_PREFIX) echo "   [GENERATE] libasteriskpj.exports"
ifeq ($(GNU_LD),1)
	$(CMD_PREFIX) echo -e "{\nglobal:" > libasteriskpj.exports
	$(CMD_PREFIX) sed -r -e "s/.*/$(LINKER_SYMBOL_PREFIX)&;/" $(ASTTOPDIR)/$(PJPROJECT_DIR)/pjproject.symbols >> libasteriskpj.exports
	$(CMD_PREFIX) echo -e "$(LINKER_SYMBOL_PREFIX)ast_pj_init;\n" >> libasteriskpj.exports
	$(CMD_PREFIX) echo -e "local:\n*;\n};" >> libasteriskpj.exports
endif

$(ASTPJ_LIB).$(ASTPJ_SO_VERSION): _ASTLDFLAGS+=-Wl,-soname=$(ASTPJ_LIB).$(ASTPJ_SO_VERSION) $(PJ_LDFLAGS)
$(ASTPJ_LIB).$(ASTPJ_SO_VERSION): _ASTCFLAGS+=-fPIC -DAST_MODULE=\"asteriskpj\" -DAST_NOT_MODULE $(PJ_CFLAGS)
$(ASTPJ_LIB).$(ASTPJ_SO_VERSION): LIBS+=$(PJPROJECT_LDLIBS) $(OPENSSL_LIB) $(UUID_LIB) -lm -lpthread $(RT_LIB)
ifeq ($(GNU_LD),1)
    $(ASTPJ_LIB).$(ASTPJ_SO_VERSION): SO_SUPPRESS_SYMBOLS=-Wl,--version-script,libasteriskpj.exports,--warn-common
endif
$(ASTPJ_LIB).$(ASTPJ_SO_VERSION): SOLINK=$(DYLINK)

# These rules are duplicated from $(ASTTOPDIR)/Makefile.rules because the library name
# being built does not match the "%.so" pattern; there are also additional steps
# required to build a proper shared library (as opposed to the 'loadable module'
# type that are built by the standard rules)
$(ASTPJ_LIB).$(ASTPJ_SO_VERSION): libasteriskpj.o libasteriskpj.exports
	$(ECHO_PREFIX) echo "   [LD] $< -> $@"
	$(CMD_PREFIX) $(CC) -o $@ $(CC_LDFLAGS_SO) $< $(CC_LIBS)

$(ASTPJ_LIB): $(ASTPJ_LIB).$(ASTPJ_SO_VERSION)
	$(ECHO_PREFIX) echo "   [LN] $< -> $@"
	$(LN) -sf $< $@ ;\

else # Darwin
ASTPJ_LIB:=libasteriskpj.dylib

# -install_name allows library to be found if installed somewhere other than
# /lib or /usr/lib
$(ASTPJ_LIB): _ASTLDFLAGS+=-dynamiclib -install_name $(ASTLIBDIR)/$(ASTPJ_LIB) $(PJ_LDFLAGS)
$(ASTPJ_LIB): _ASTCFLAGS+=-fPIC -DAST_MODULE=\"asteriskpj\" $(PJ_CFLAGS) -DAST_NOT_MODULE
$(ASTPJ_LIB): LIBS+=$(PJPROJECT_LIB) $(OPENSSL_LIB) $(UUID_LIB) -lm -lpthread $(RT_LIB)
$(ASTPJ_LIB): SOLINK=$(DYLINK)

# Special rules for building a shared library (not a dynamically loadable module)
$(ASTPJ_LIB): libasteriskpj.o
	$(ECHO_PREFIX) echo "   [LD] $^ -> $@"
	$(CMD_PREFIX) $(CC) -o $@ $(CC_LDFLAGS_SO) $^ $(CC_LIBS)
endif

endif

$(MAIN_TGT): $(OBJS) $(MOD_OBJS) $(ASTSSL_LIB) $(ASTPJ_LIB)
	@$(CC) -c -o buildinfo.o $(_ASTCFLAGS) buildinfo.c $(ASTCFLAGS)
	$(ECHO_PREFIX) echo "   [LD] $(OBJS) $(MOD_OBJS) -> $@"
	$(CMD_PREFIX) $(CXX) -o $@ $(ASTLINK) $(_ASTLDFLAGS) $(ASTLDFLAGS) $(OBJS) $(MOD_OBJS) $(ASTSSL_LDLIBS) $(ASTPJ_LDLIBS) buildinfo.o $(AST_LIBS) $(GMIMELDFLAGS) $(LIBEDIT_LIB)

ifeq ($(GNU_LD),1)
$(MAIN_TGT): asterisk.exports
asterisk.exports: asterisk.exports.in
	$(CMD_PREFIX) $(ASTTOPDIR)/build_tools/make_linker_version_script asterisk $(LINKER_SYMBOL_PREFIX)
endif

bininstall:
	$(INSTALL) -m 755 $(MAIN_TGT) "$(DESTDIR)$(ASTSBINDIR)/"
ifeq ($(AST_ASTERISKSSL),yes)
ifeq ($(findstring darwin,$(OSARCH)),) # not Darwin
	$(INSTALL) -m 755 $(ASTSSL_LIB).$(ASTSSL_SO_VERSION) "$(DESTDIR)$(ASTLIBDIR)/"
	$(LN) -sf $(ASTSSL_LIB).$(ASTSSL_SO_VERSION) "$(DESTDIR)$(ASTLIBDIR)/$(ASTSSL_LIB)"
else # Darwin
	$(INSTALL) -m 755 $(ASTSSL_LIB) "$(DESTDIR)$(ASTLIBDIR)/"
endif
endif

=== debian/changelog ===
asterisk (1:22.2.0~dfsg+~cs6.15.60671435-2) unstable; urgency=medium

  * add patch cherry-picked upstream
    to fix res_config_pgsql regression that removed dbname config;
    closes: bug#1098486, thanks to Andrey N. Abelev
  * declare compliance with Debian Policy 4.7.1

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 22 Feb 2025 08:54:51 +0100

asterisk (1:22.2.0~dfsg+~cs6.15.60671435-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update watch file: track pjproject 2.15.1
  * update and unfuzz patches
  * update copyright info: update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 11 Feb 2025 20:53:26 +0100

## asterisk 22.2.0~dfsg+~cs6.15.60671435

=== apps/Makefile ===
#
# Asterisk -- An open source telephony toolkit.
#
# Makefile for PBX applications
#
# Copyright (C) 1999-2006, Digium, Inc.
#
# This program is free software, distributed under the terms of
# the GNU General Public License
#

-include $(ASTTOPDIR)/menuselect.makeopts $(ASTTOPDIR)/menuselect.makedeps

MODULE_PREFIX=app
MENUSELECT_CATEGORY=APPS
MENUSELECT_DESCRIPTION=Applications

MENUSELECT_OPTS_app_directory:=$(MENUSELECT_OPTS_app_voicemail)

all: _all

include $(ASTTOPDIR)/Makefile.moddir_rules

.app_voicemail.moduleinfo: app_voicemail.c
	@echo "<member name=\"app_voicemail\" displayname=\"$(shell $(GREP) -e AST_MODULE_INFO $< | head -n 1 | cut -d '"' -f 2)\" remove_on_change=\"$(SUBDIR)/$*.o $(SUBDIR)/$*.so\">" > $@
	echo "<support_level>core</support_level>"  >> $@
	echo "<defaultenabled>yes</defaultenabled>" >> $@
	echo "<use type=\"module\">res_adsi</use>" >> $@
	echo "<use type=\"module\">res_smdi</use>" >> $@
	echo "</member>" >> $@

.app_voicemail_imap.moduleinfo: app_voicemail_imap.c
	@echo "<member name=\"app_voicemail_imap\" displayname=\"$(shell $(GREP) -e AST_MODULE_INFO $< | head -n 1 | cut -d '"' -f 2)\" remove_on_change=\"$(SUBDIR)/$*.o $(SUBDIR)/$*.so\">" > $@
	echo "<support_level>core</support_level>"  >> $@
	echo "<defaultenabled>no</defaultenabled>" >> $@
	echo "<depend>imap_tk</depend>" >> $@
	echo "<use type=\"module\">res_adsi</use>" >> $@
	echo "<use type=\"module\">res_smdi</use>" >> $@
	echo "</member>" >> $@

.app_voicemail_odbc.moduleinfo: app_voicemail_odbc.c
	@echo "<member name=\"app_voicemail_odbc\" displayname=\"$(shell $(GREP) -e AST_MODULE_INFO $< | head -n 1 | cut -d '"' -f 2)\" remove_on_change=\"$(SUBDIR)/$*.o $(SUBDIR)/$*.so\">" > $@
	echo "<support_level>core</support_level>"  >> $@
	echo "<defaultenabled>no</defaultenabled>" >> $@
	echo "<depend>generic_odbc</depend>" >> $@
	echo "<use type=\"module\">res_adsi</use>" >> $@
	echo "<use type=\"module\">res_smdi</use>" >> $@
	echo "</member>" >> $@

$(call MOD_ADD_C,app_confbridge,$(wildcard confbridge/*.c))

app_confbridge.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION)
app_meetme.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION)
app_minivm.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION)
app_voicemail.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION) -DFILE_STORAGE
app_voicemail_odbc.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION) -DODBC_STORAGE
app_voicemail_imap.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION) -DIMAP_STORAGE
app_while.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION)

ifneq ($(findstring $(OSARCH), mingw32 cygwin ),)
  LIBS+= -lres_ael_share.so -lres_speech.so
  LIBS+= -lres_smdi.so
endif

=== debian/control ===
--- 
+++ 
@@ -76,7 +76,7 @@
  unixodbc-dev,
  uuid-dev,
  zlib1g-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.1
 Homepage: https://www.asterisk.org/
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/asterisk.git
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/asterisk

=== debian/rules ===
#!/usr/bin/make -f

# resolve DEB_VERSION_UPSTREAM DEB_VERSION_UPSTREAM_REVISION DEB_DISTRIBUTION
include /usr/share/dpkg/pkg-info.mk

# resolve DEB_BUILD_ARCH_OS DEB_HOST_MULTIARCH
include /usr/share/dpkg/architecture.mk

# generate documentation unless nodoc requested
CHANGELOGS_stem = ChangeLogs/ChangeLog-$(firstword $(subst ~, ,$(subst ~~,-,$(DEB_VERSION_UPSTREAM))))
DOCS_stem = README SECURITY
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
CHANGELOGS = $(CHANGELOGS_stem:=.html) $(CHANGELOGS_stem:=.txt)
DOCS = $(DOCS_stem:=.html) $(DOCS_stem:=.txt)
MANPAGES = debian/build/dh_asterisk.1
endif

# enable hardening compiler options
# see <https://wiki.debian.org/Hardening#Using_Hardening_Options>
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# revive upstream optimization flags unless DEB_BUILD_OPTIONS=noopt
# code allegedly fails partial-inlining optimization with GCC >= 8.2.1,
# see <Makefile.rules> and upstream git commit 449dff9
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
DEB_CFLAGS_MAINT_STRIP = -O2
DEB_CFLAGS_MAINT_APPEND = -O3 -fno-partial-inlining
endif
include /usr/share/dpkg/buildflags.mk

# Pass CPPFLAGS in the CFLAGS as otherwise the build system will
# ignore them.
CFLAGS += $(CPPFLAGS)

LDFLAGS += -Wl,--as-needed

# Sanity check for a stable release:
SAVED_ABI_HASH = 1fb7f5c06d7a2052e38d021b3d8ca151

# resolve PJPROJECT version
PJMAJ = $(shell grep -Po '^export PJ_VERSION_MAJOR\s+:=\s+\K\d+' Xpjproject/version.mak)
PJMIN = $(shell grep -Po '^export PJ_VERSION_MINOR\s+:=\s+\K\d+' Xpjproject/version.mak)
PJREV = $(shell grep -Po '^export PJ_VERSION_REV\s+:=\s+\K\d+' Xpjproject/version.mak)
PJVER := $(PJMAJ)$(if $(PJMIN),.$(PJMIN)$(if $(PJREV),.$(PJREV)))

PJDIR = debian/build-pjproject

# don't let asterisk mess with build flags
BUILDFLAGS += AST_FORTIFY_SOURCE= DEBUG= OPTIMIZE=

# show full gcc arguments unless DEB_BUILD_OPTIONS=terse
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
BUILDFLAGS += NOISY_BUILD=yes
endif

BUILDFLAGS += ASTDATADIR=/usr/share/asterisk ASTVARRUNDIR=/var/run/asterisk

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

ADDONS_ENABLE = app_voicemail_imap app_voicemail_odbc
ADDONS_ENABLE += res_config_mysql
ADDONS_ENABLE += chan_mobile chan_ooh323
ADDONS_ENABLE += codec_opus_open_source
ADDONS_ENABLE += aelparse format_mp3 smsq TEST_FRAMEWORK
ADDONS_DISABLE = BUILD_NATIVE
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
ADDONS_ENABLE += BETTER_BACKTRACES DEBUG_THREADS
endif

# make sure we have 'fetch' . We need to have either wget or fetch
# on the system. However it is generally not a good idea to actually
# get remote tarballs at build time. So if neither wget nor fetch
# happen to be installed, the configure script will find a dummy
# fetch script that always returns an error.
FETCH_ENV = PATH=$$PATH:$(CURDIR)/debian/dummyprogs

# resolve if release is experimental
EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))

export deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)

%:
	dh $@

%.html: %.md
	cmark-gfm $< > $@

%.txt: %.md
	cmark-gfm --to plaintext $< > $@

override_dh_autoreconf:
	if [ ! -r configure.debian_sav ]; then cp -a configure configure.debian_sav; fi
	[ -f .version.debian_sav ] || cp -a .version .version.debian_sav
	echo $(DEB_VERSION_UPSTREAM_REVISION) > .version
	dh_autoreconf -- ./bootstrap.sh

execute_before_dh_auto_configure:
	chmod 755 debian/dummyprogs/fetch
	# create DSFG-free version of pjproject source
	# as upstream build expects it
	mkdir --parents $(PJDIR)
	rm -f $(PJDIR)/pjproject-${PJVER}
	ln --symbolic ../../Xpjproject $(PJDIR)/pjproject-${PJVER}
	( cd $(PJDIR) && tar --create pjproject-${PJVER}/* ) \
		| bzip2 --fast > $(PJDIR)/pjproject-${PJVER}.tar.bz2
	cp third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5 third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5.debian_sav
	( cd $(PJDIR) && md5sum pjproject-${PJVER}.tar.bz2 ) > third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5

	cp --force --recursive --target-directory=. Xamr/codecs Xamr/include Xamr/res

	rm --force --recursive addons/mp3
	mkdir addons/mp3
	cp --force --target-directory=addons/mp3 Xmp3/*

	cp --force --recursive --target-directory=. Xopus/codecs Xopus/formats

override_dh_auto_configure:
	TMPDIR="$(CURDIR)/$(PJDIR)" $(FETCH_ENV) dh_auto_configure -- \
		--disable-asteriskssl \
		--with-gsm \
		--with-imap=system \
		--without-pwlib \
		$(if $(EXP_RELEASE),,--without-sdl) \
		$(if $(findstring debug,$(DEB_BUILD_OPTIONS)),--enable-dev-mode) \
		|| { cat config.log; exit 1; }

#		--with-cap \

execute_before_dh_auto_build:
	$(MAKE) menuselect.makeopts BUILD_CFLAGS="$(CFLAGS)" BUILD_LDFLAGS="$(LDFLAGS)"
	for module in $(ADDONS_ENABLE); do menuselect/menuselect --enable $$module menuselect.makeopts; done
	for module in $(ADDONS_DISABLE); do menuselect/menuselect --disable $$module menuselect.makeopts; done

override_dh_auto_build:
	$(FETCH_ENV) dh_auto_build -- $(BUILDFLAGS)

execute_after_dh_auto_build: $(DOCS) $(CHANGELOGS) $(MANPAGES)
	# Sanity check: don't break the ABI for modules:
	@abi_hash=$$(awk -F'"' '/AST_BUILDOPT_SUM/ {print $$2}' \
	  include/asterisk/buildopts.h); \
	  if [ "$$abi_hash" != "$(SAVED_ABI_HASH)" ]; then \
	    echo "Debian packaging problem: ABI checksum changed."; \
	    echo "  Was: $(SAVED_ABI_HASH)"; \
	    echo "  Now: $$abi_hash"; \
	    echo "Check include/asterisk/buildopts.h"; \
	    [ -n "$(EXP_RELEASE)" ] || exit 1; \
	  fi

SND_FILE=asterisk-core-sounds-en-gsm-1.4.20.tar.gz
execute_before_dh_clean:
	[ ! -r sounds/$(SND_FILE) ] || mv sounds/$($SND_FILE) debian/
	GREP=grep AWK=awk $(MAKE) distclean
	[ ! -r debian/$(SND_FILE) ] || mv debian/$(SND_FILE) sounds/

	[ ! -f .version.debian_sav ] || mv .version.debian_sav .version
	[ ! -f configure.debian_sav ] || mv configure.debian_sav configure
	[ ! -f third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5.debian_sav ] \
	  || mv third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5.debian_sav \
	  third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5

override_dh_gencontrol:
	AST_BUILDOPT_SUM=$$(grep AST_BUILDOPT_SUM include/asterisk/buildopts.h  \
		| sed -e 's/.\+ "\(.\+\)\"/\1/g'); \
		dh_gencontrol -- -Vasterisk:ABI=$$AST_BUILDOPT_SUM

REMOVED_PROTO_CONFS = dundi unistim
REMOVED_PROTO_FILES = $(REMOVED_PROTO_CONFS:%=debian/tmp/etc/asterisk/%.conf)
SUBPACKS_EXTRA = ooh323 mysql mp3
ifeq (linux,$(DEB_BUILD_ARCH_OS))
SUBPACKS_EXTRA += dahdi mobile tests
endif
SUBPACKS_EXTRA_DIRS = $(SUBPACKS_EXTRA:%=debian/asterisk-%)
SUBPACKS_EXTRA_DIRS_MOD = $(SUBPACKS_EXTRA_DIRS:%=%/usr/lib/$(DEB_HOST_MULTIARCH)/asterisk/modules)

override_dh_auto_install:
	$(FETCH_ENV) dh_auto_install -- $(BUILDFLAGS) -j1 config samples install-headers

execute_after_dh_auto_install:
	cp -a configs debian/tmp/usr/share/asterisk/conf
	$(RM) -f $(REMOVED_PROTO_FILES)
	mkdir -p debian/tmp/usr/bin/
	mkdir -p debian/tmp/usr/share/man/man1
	mkdir -p debian/tmp/usr/share/dahdi/span_config.d
	cp -a debian/asterisk-config-custom debian/tmp/usr/bin/
	cp -a debian/asterisk-config-custom.1 debian/tmp/usr/share/man/man1/
	cp -a debian/50-asterisk debian/tmp/usr/share/dahdi/span_config.d/
	mkdir -p debian/tmp/$(deb_systemdsystemunitdir)
	test "$(deb_systemdsystemunitdir)" != "lib/systemd/system" && mv debian/tmp/lib/systemd/system/* debian/tmp/$(deb_systemdsystemunitdir)/ || true
	rmdir --ignore-fail-on-non-empty --parents debian/tmp/lib/systemd/system
	$(RM) -f debian/tmp/usr/sbin/conf2ael
	$(RM) -f debian/tmp/usr/sbin/muted
	$(RM) -f debian/tmp/usr/sbin/streamplayer
	$(RM) -f debian/tmp/usr/sbin/stereorize
	$(RM) -f debian/tmp/usr/sbin/hashtest*
	$(RM) -f debian/tmp/usr/sbin/refcounter

execute_after_dh_install-arch:
	extra_packs=$$(find $(SUBPACKS_EXTRA_DIRS_MOD) -name '*.so' -printf '%f\n');\
	  cd debian/asterisk-modules/usr/lib/$(DEB_HOST_MULTIARCH)/asterisk/modules \
	  && rm -f $$extra_packs

override_dh_installdocs:
	dh_installdocs --all -- $(DOCS)

=== debian/watch ===
--- 
+++ 
@@ -36,4 +36,4 @@
 filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-Xpjproject-$1/,\
 dversionmangle=auto \
 https://github.com/pjsip/pjproject/tags \
-.*?(2\.14\.1)@ARCHIVE_EXT@ checksum
+.*?(2\.15\.1)@ARCHIVE_EXT@ checksum

## asterisk 22.4.1~dfsg+~cs6.15.60671435

=== debian/changelog ===
asterisk (1:22.4.1~dfsg+~cs6.15.60671435-2) unstable; urgency=medium

  * build-depend on libcrypt-dev;
    closes: bug#1107016, thanks to Helmut Grohne

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 31 May 2025 21:58:04 +0200

asterisk (1:22.4.1~dfsg+~cs6.15.60671435-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)
    + add option to restrict shell access from remote consoles;
      CVE-2025-47780;
      closes: bug#1106530, thanks to Salvatore Bonaccorso
    + mask control characters in received From display name;
      CVE-2025-47779;
      closes: bug#1106528, thanks to Salvatore Bonaccorso

  [ Chris Maj ]
  * remove IMAP voicemail backend, because libc-client2007e is gone;
    stop build-depend on libc-client2007e-dev;
    closes: bug#1103048, thanks to Chris Hofstaedtler
  * add self as uploader

  [ Jonas Smedegaard ]
  * unfuzz patches
  * update copyright info: update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 27 May 2025 14:36:46 +0200

asterisk (1:22.3.0~dfsg+~cs6.15.60671435-1) unstable; urgency=medium

  [ upstream ]
  * new release

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 27 Mar 2025 16:58:35 +0100

asterisk (1:22.3.0~~rc1~dfsg+~cs6.15.60671435-1) unstable; urgency=medium

  [ upstream ]
  * new prerelease

  [ Jonas Smedegaard ]
  * unfuzz patches
  * declare compliance with Debian Policy 4.7.2

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 26 Mar 2025 17:18:00 +0100

## asterisk 22.5.1~dfsg+~cs6.15.60671435

=== debian/changelog ===
asterisk (1:22.5.1~dfsg+~cs6.15.60671435-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)
    + test for missing semicolon in res_stir_shaken Identity header;
      CVE-2025-49832;
      closes: bug#1110317, thanks to Salvatore Bonaccorso

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 03 Aug 2025 11:18:38 +0200

## asterisk 22.5.2~dfsg%2B~cs6.15.60671435

=== third-party/Makefile ===

-include ../makeopts
include Makefile.rules

TP_ALL_SUBDIRS := jansson pjproject libjwt

TP_SUBDIRS :=
# Sub directories that contain special install/uninstall targets must be explicitly listed
# to prevent accidentally running the package's default install target.
TP_INSTALL_SUBDIRS :=

ifeq ($(PJPROJECT_BUNDLED),yes)
TP_SUBDIRS += pjproject
TP_INSTALL_SUBDIRS += pjproject
endif

ifeq ($(JANSSON_BUNDLED),yes)
TP_SUBDIRS += jansson
TP_INSTALL_SUBDIRS += jansson
endif

ifeq ($(LIBJWT_BUNDLED),yes)
TP_SUBDIRS += libjwt
TP_INSTALL_SUBDIRS += libjwt
libjwt: jansson
export JANSSON_CFLAGS=$(JANSSON_INCLUDE)
export JANSSON_LIBS=$(JANSSON_LIB)
endif

override MAKECMDGOALS?=all
MAKECMDGOALS:=$(subst dist-clean,distclean,$(MAKECMDGOALS))

.PHONY: all dist-clean distclean install clean moduleinfo makeopts uninstall $(TP_ALL_SUBDIRS)

ifeq ($(findstring clean,$(MAKECMDGOALS)),clean)
distclean dist-clean clean : $(TP_ALL_SUBDIRS)
TP_RUN_SUBDIRS := $(TP_ALL_SUBDIRS)
else
all install uninstall : $(TP_SUBDIRS)
install uninstall: $(TP_INSTALL_SUBDIRS)
TP_RUN_SUBDIRS := $(TP_SUBDIRS)
endif

ifneq ($(TP_RUN_SUBDIRS),)

$(TP_RUN_SUBDIRS):
	+$(CMD_PREFIX) $(SUBMAKE) -C $@ $(MAKECMDGOALS)

endif

=== pjsip-apps/src/swig/python/Makefile ===
--- 
+++ 
@@ -26,8 +26,11 @@
 SRC_DIR=../../../../pjsip/include
 SRCS=$(SRC_DIR)/pjsua2/endpoint.hpp $(SRC_DIR)/pjsua2/types.hpp
 
-USE_THREADS = -threads -DSWIG_NO_EXPORT_ITERATOR_METHODS
-SWIG_FLAGS += -w312 $(USE_THREADS)
+GEN_DOC = -doxygen
+USE_THREADS = -threads
+# In SWIG 4.2 the build will fail if we use this flag
+#-DSWIG_NO_EXPORT_ITERATOR_METHODS
+SWIG_FLAGS += -w312 $(USE_THREADS) $(GEN_DOC)
 
 .PHONY: all install uninstall

=== debian/changelog ===
asterisk (1:22.5.2~dfsg+~cs6.15.60671435-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)
    + A specifically malformed Authorization header
      in an incoming SIP request can cause Asterisk to crash
      CVE-2025-57767;
      closes: bug#1112470, thanks to Salvatore Bonaccorso

  [ Jonas Smedegaard ]
  * update copyright info:
    + strip upstream-autogenerated file README.html
      from repackaged source
  * update watch file: use file format 5

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 29 Aug 2025 22:00:21 +0200
